/******************************************************************************/
/*Files to Include                                                            */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */
#include "user.h"
/******************************************************************************/
/* Interrupt Routines                                                         */
/******************************************************************************/

/* Baseline devices don't have interrupts. Note that some PIC16's 
 * are baseline devices.  Unfortunately the baseline detection macro is 
 * _PIC12 */
#ifndef _PIC12

void interrupt isr(void)
{
    /* This code stub shows general interrupt handling.  Note that these
    conditional statements are not handled within 3 seperate if blocks.
    Do not use a seperate if block for each interrupt flag to avoid run
    time errors. */

#if 1
    
    /* TODO Add interrupt routine code here. */

    /* Determine which flag generated the interrupt */
    if(RCIF)
    {
        // RX interrupt
        char MessageReceived = RCREG;
        if (LockState==LOCKED && MessageReceived == 'u')
        {
            UnlockMessage = true;
        }else if (LockState == UNLOCKED && MessageReceived == 'l')
        {
            LockMessage = true;
        }

    }
    else if (T0IF)
    {        
        pulse_counter++;
        move_counter++;
        if((LockState == LOCKING)&&(pulse_counter > lock_ticks) ||
            (LockState == UNLOCKING)&&(pulse_counter > unlock_ticks))
        {
            PWM_PIN = 0;
        }
        if(pulse_counter > pulse_ticks)
        {
            PWM_PIN = 1;
            pulse_counter = 0;
        }
        if(move_counter > move_ticks)
        {
            DoneMoving = true;
            move_counter = 0;
        }
        if(move_counter%1000 == 0)
        {
            // blink LED while unlocking/locking
            LED_PIN = !LED_PIN;
        }

        T0IF = 0;
        TMR0 = 156;
    }
    else
    {
        /* Unhandled interrupts */
    }

#endif

}
#endif


