/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#include "user.h"

/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/

/* <Initialize variables in user.h and insert code for user algorithms.> */

void InitApp(void)
{
    /* TODO Initialize User Ports/Peripherals/Project here */
    IRCF0 = 1;
    IRCF1 = 1;
    IRCF2 = 1;  // use 8MHz clock

    /* Setup analog functionality and port direction */
    ANSEL = 0;
    ANSELH = 0;
    TRISC0 = 0; // RC0 = LED OUTPUT
    TRISC1 = 0; // RC1 = PWM output
    PWM_PIN = 0;
    LED_PIN = 0;
    /* Initialize peripherals */


      /* Init TIMER0: Period = Fosc/4 x Prescaler x TMR0
         0.0005 ms x 2 * 100 = 0.1 ms */
    PSA = 0; // prescaler on timer 0
    //PSA = 1; // no prescaler
    T0CS = 0; // timer mode
    PS0 = 0; // prescaler = 2
    PS1 = 0;
    PS2 = 0;
    TMR0 = 156;  // 256-156 = 100 TICKS

/***********************************UART ***********************************/
    // Enable UART TX
    TXEN = 1;   // Transmit hardware enable
    SYNC = 0;   // Asynchronous mode
    SPEN = 1;   // Serial port enable

    // Enable UART RX
    CREN = 1;   // Receive hardware enable

    /* Setup UART:
     *  Baud rate 115,200
     *  8 bits (default)
     *  No Parity (default)
     *  1 stop bit
     *  Hardware flow control enabled */

    BRGH = 1;   //High baud rate
    BRG16 = 1;  //16 bit baud rate
    SPBRG = 16;  // Set des_baud = Fosc/[4(n+1)] where Fosc = 8MHz
/*****************************************************************************/
    
    /* Enable interrupts */
    // Enable RX interrupt
    T0IE = 1;
    RCIE = 1;
    PEIE = 1;  // Peripheral interrupt enable
    GIE = 1;    // Global interrupt enable
}

